//	---------------------------------------------------------------------------
//	$Header: /home/xmdv/CODE/CVSREPOSITORY/xmdvtool/ext/libs/xmdvdbg/log/nullstream.h,v 1.1 2004/04/13 22:03:57 anil Exp $
//
//	(c) Copyright 2002 Anthony Bowyer-Lowe.  All rights reserved.
//
//	Anthony Bowyer-Lowe / ynohtna
//	ynohtna@ynohtna.org
//	http://www.ynohtna.org/
//	---------------------------------------------------------------------------

#if !defined(ANTHONY_NULLSTREAM_HEADER)
#define ANTHONY_NULLSTREAM_HEADER

#include <ios>

namespace debug
{
namespace log
{

template<typename E, typename T = std::char_traits<E> >
class basic_nullbuf : public std::basic_streambuf<E, T>
{
public:
    basic_nullbuf()
    {    }

protected:
    int_type overflow(int_type ch = traits_type::eof())
    {
        return traits_type::not_eof(ch);
    }

private:
    basic_nullbuf(const basic_nullbuf&);
    basic_nullbuf& operator=(const basic_nullbuf&);
};


template<typename E, typename T = std::char_traits<E> >
class basic_nullstream : public std::basic_ostream<E, T>
{
private:
    basic_nullbuf<E, T>*    pbuf;

public:
    basic_nullstream() : std::basic_ostream<E, T>(pbuf = new basic_nullbuf<E, T>)
    {    }

    ~basic_nullstream()
    {
        pbuf->pubsync();
        delete pbuf;
    }
};


typedef basic_nullstream<char>      nullstream;
typedef basic_nullstream<wchar_t>   nullstreamw;

} // End namespace log
} // End namespace debug

#endif // ANTHONY_NULLSTREAM_HEADER
