#ifndef DB_LOADER_H
#define DB_LOADER_H

#include<backend/db_buffer.h>
#include<xmdv/ARR.h>

//////////////////////////////////////////////////////////////////////////
////This methods loads the data from the data base into the buf
////@param left : Left extent
////@param right: Right extent
////@param L :level of detail
////@param buf: Buffer to be loaded
////@param asc: Order
////@param path : The name of the table
////////////////////////////////////////////////////////////////////////

extern "C" int	db_get_levels(char *);
extern "C" int	db_get_leaves(char *);
//////////////////////////////////////////////////////////////////
////This method forms an histogram of the different tree_radius and the
//// no_of_nodes of the array. Therefore this method populates the 2 arrays
////Also it assumes that the table stucture has been instantiated
//// @param tree_radius[], An array
//// @param no_of_nodes[], An array
/////////////////////////////////////////////////////////////////
extern "C" void db_radius(double tree_radius[],long no_of_nodes[]);

/////////////////////////////////////////////////////////
////@return int, Returns the number of levels in the complete data set
//////////////////////////////////////////////////////////

extern "C" int db_get_height();
//////////////////////////////////////////////////////////////////
////@param lowerLimit
////@param upperLimit
////@return long, Returns the number of nodes in between which have sqrt_radius
//// >= lower limit and < upper limit
//////////////////////////////////////////////////////////////////
extern "C" long get_no_of_nodes_between(double lower_limit,double upper_limit);

/////////////////////////////////////////////////////////////////
////This mehtod returns the number of disticnt radius values in the data base
////@return long
/////////////////////////////////////////////////////////////////
extern "C" long get_no_of_radius_values();

////////////////////////////////////////////////////////////////////////////
////This method retreives the number of nodes that will contribute 
////at this radius value given
////@param double radius
///////////////////////////////////////////////////////////////////////////
extern "C" long no_of_nodes_at(const double radius);

/////////////////////////////////////////////////////////////////
////It finds the nodes that will be displayed for the given value of radius
////For each node we populate the radius
////the radius of the parent
////height of the node in the tree
////@param &arr_radius, An array passed by reference
////@param &arr_parent_radius. An array passed by reference
////@param arr_height, An array passsed by referece stores the height of the 
////node in the tree.
////@return void
/////////////////////////////////////////////////////////////////
extern "C" void get_nodes_at(double at_radius,
				  double *arr_radius,
				  double *arr_parent_radius,
				  int *arr_height);
///////////////////////////////////////////////////////////////////////
/////
/////
/////
////////////////////////////////////////////////////////////////////////
extern "C" double db_get_root_radius(char *path);
///////////////////////////////////////////////////////////////////////
/////This function closes down the Oracle connection
/////
/////
////////////////////////////////////////////////////////////////////////
extern "C" void release_connection();

#endif
