#ifndef DB_GLOBAL_H
#define DB_GLOBAL_H

#define ORACLE_CACHE		0
//  -1:  default - no hint
//   0:  nocache hint
//   1:  cache hint


// for prefetching --------------------------------------------
#define DO_PREFETCHING		0
// (ger) set to 1 to activate prefetching, 0 otherwise
#define NO_PREFETCH			0
#define RANDOM_PREFETCH		1
#define DIRECTION_PREFETCH	2
#define FOCUS_PREFETCH		3

// for Adaptive Prefetching -----------------------------------
//Removed Adaptive Prefetching

#define STRATEGY_MAXID      4  // number of strategies listed above 


// set to 1 to do incremental loading, 0 otherwise
//	#define BUFFER_SIZE_BYTES	 512
//	#define BUFFER_SIZE_BYTES	1024 
//	#define BUFFER_SIZE_BYTES	5120
#define BUFFER_SIZE_BYTES	1048576 
// maximum cache size (1kb = 1024 bytes)
#define PCT_REDUCTION_LOADSIZE	0.9
// if load is too big, reduce range by this percentage
#define XY_EXTENT_OFFSET	0
// add this value to x or y extent to prevent overlapping x,y ranges
// this value must be very very small. ?? remove this

// for debugging ----------------------------------------------
#define BACKEND_DEBUG  0
// set to 1 to produce debugging print lines,  0 otherwise
#define OUTFILE				"./RunLog/outFile.txt"
// filename to contain debug file. use with BACKEND_DEBUG flag

#define PRINTFILE			"./RunLog/printFile.txt"
// filename to contain detailed adaptive prefetching output
#define OUTPUTFILE			"./RunLog/outputFile.txt"
// filename to contain summary/overall adaptive prefetching output
#define ERRFILE				"./RunLog/errFile.txt"
#define TRACKFILE			"./RunLog/trackFile.txt"
#define HOTREGIONFILE		"./RunLog/hotRegions.txt"

//Added temporarily
#define NO

#endif
