/* file: globalAverage.h
 * purpose: Definitions for Global Average class
 * revision log:
 */

typedef struct globalAverage_Str *globalAverage;
 /* Defines 'globalAverage' as a pointer to a structure that
  * is not defined here and so is not accessible to the outside world
  */

globalAverage globalAverage_Create() ;
 /*	Returns a new globalAverage, or NULL if there isn't enough memory.
  */

void globalAverage_Destroy(globalAverage g) ;
 /* Frees the memory associated with 'globalAverage'. 
  */

float globalAverage_Update(globalAverage g, float m) ;
 /* Updates the global average value with the new meaure 
  */

float globalAverage_GetValue(globalAverage g) ;
 /*	Returns the latest value of the global average in float form
  */

void globalAverage_Test() ;
 /* Tests the entire global average class 
  */