
#include <xmdv/CScatter.h>
#include <xmdv/XmdvTool.h>
#include <xmdv/ogl.h>
#include <xmdv/CDimReducer.h>
#include <xmdv/CScreenDistortion.h>
#include <xmdv/okcdata.h>

CScatter::CScatter()
{
}


CScatter::~CScatter()
{
}


bool CScatter::ScatterTestDimensionality()
{
	if ( g_globals.dataset->dims < 1 )
		return false;
	else 
		return true;
}


// Draw grid.
void CScatter::DrawScatterGrid(grCanvas *canvas)
{
	int i,j;

    glLineWidth(1.);
    glShadeModel(GL_SMOOTH);
    canvas->SetForeground(interface_color[GRID1]);
    canvas->SetXorMode(false);

	// Ths is naughty code that takes forever
/*
    int i;
    for (i = 0;i < g_globals.dataset->dims;i++)
		for (int j = 0;j < g_globals.dataset->dims;j++)
            canvas->DrawRectangle2(g_globals.screen_distortion->scatter_X_axes[i], 
								   g_globals.screen_distortion->scatter_X_axes[i+1], 
                                   g_globals.screen_distortion->scatter_Y_axes[j], 
								   g_globals.screen_distortion->scatter_Y_axes[j+1] );
*/

	//canvas->BeginDraw();
	canvas->bypassAll(true);

	// PAUL: draw_simple scatter_bounds
	// X
	// Instead of drawing squares for each individual scatter plot, instead
	// draw them all at once in a tic-tac-toe grid fashion
	for (i = xMinDim; i <= xMaxDim;i++)
	{
		canvas->DrawLine(	(float)g_globals.screen_distortion->scatter_X_axes[i],
							(float)g_globals.screen_distortion->scatter_Y_axes[yMinDim],
							(float)g_globals.screen_distortion->scatter_X_axes[i],
							(float)g_globals.screen_distortion->scatter_Y_axes[yMaxDim]);
	}
	// Y
	for (j = yMinDim; j <= yMaxDim; j++)
	{
		canvas->DrawLine(	(float)g_globals.screen_distortion->scatter_X_axes[xMinDim],
							(float)g_globals.screen_distortion->scatter_Y_axes[j],
							(float)g_globals.screen_distortion->scatter_X_axes[xMaxDim],
							(float)g_globals.screen_distortion->scatter_Y_axes[j]);
	}

	//canvas->EndDraw();
	canvas->bypassAll(false);

	

/* for fisheye view
	int i;
	for ( i = 0; i <= g_globals.dataset->dims; i++ )
		canvas->DrawLineTemp(screen_distortion->scatter_X_axes[i], screen_distortion->scatter_Y_axes[0],
								screen_distortion->scatter_X_axes[i], screen_distortion->scatter_Y_axes[g_globals.dataset->dims]);
	for ( i = 0; i <= g_globals.dataset->dims; i++ )
		canvas->DrawLineTemp(screen_distortion->scatter_X_axes[0], screen_distortion->scatter_Y_axes[i],
								screen_distortion->scatter_X_axes[g_globals.dataset->dims], screen_distortion->scatter_Y_axes[i]);
*/

//jing draw the labels of the plots
    // do labels
    canvas->SetForeground(interface_color[TEXT]);

    Vec2 font_size = canvas->GetDataFontSize("W");

    // draw horizontal labels
    // add letters one at a time until space runs out
    for (i=0; i<g_globals.dataset->dims; i++)
    {
        double y = .8*font_size.Y;
        canvas->DrawConfinedString(g_globals.screen_distortion->scatter_X_axes[i],y,g_globals.dataset->names[i],
								   g_globals.screen_distortion->scatter_X_interval[i]-font_size.X*3);
    }

    // draw vertical labels
    // add letters one at a time until space runs out
    for (i=0; i<g_globals.dataset->dims; i++)
    {
        // initial coordinates
        Vec2 p;
        p.X = -2.5*font_size.X;
        p.Y = g_globals.screen_distortion->scatter_Y_axes[i]; // - font_size.Y*1.1;

        for (int j=0; j<int(strlen(g_globals.dataset->names[i])); j++)
        {
            Vec2 letter = canvas->GetDataFontSize(&g_globals.dataset->names[i][j],1);
            p.Y -= 1.2*letter.Y;

            if (p.Y > g_globals.screen_distortion->scatter_Y_axes[i+1]+letter.Y) break;

            canvas->DrawString(p.X,p.Y,&g_globals.dataset->names[i][j],1);
        }
    } 
}

// Draw grid.
void CScatter::DrawScatterGridWithTwoAxes(grCanvas *canvas)
{
    int i;
    glLineWidth(3.);
    glShadeModel(GL_SMOOTH);
    canvas->SetXorMode(false);

    canvas->SetForeground(interface_color[GRID2]);
    for (i = 0;i < g_globals.dataset->dims;i++)
    {        
        canvas->DrawLine((float)g_globals.screen_distortion->scatter_X_axes[i], 
						(float)g_globals.screen_distortion->scatter_Y_axes[i], 
                        (float)g_globals.screen_distortion->scatter_X_axes[i+1], 
						(float)g_globals.screen_distortion->scatter_Y_axes[i] );
        canvas->DrawLine((float)g_globals.screen_distortion->scatter_X_axes[i], 
						(float)g_globals.screen_distortion->scatter_Y_axes[i+1], 
                        (float)g_globals.screen_distortion->scatter_X_axes[i+1], 
						(float)g_globals.screen_distortion->scatter_Y_axes[i+1] );
    }

    canvas->SetForeground(interface_color[GRID3]);
    for (i = 0;i < g_globals.dataset->dims;i++)
    {        
        canvas->DrawLine((float)g_globals.screen_distortion->scatter_X_axes[i], 
						(float)g_globals.screen_distortion->scatter_Y_axes[i], 
                        (float)g_globals.screen_distortion->scatter_X_axes[i], 
						(float)g_globals.screen_distortion->scatter_Y_axes[i+1] );
        canvas->DrawLine((float)g_globals.screen_distortion->scatter_X_axes[i+1], 
						(float)g_globals.screen_distortion->scatter_Y_axes[i], 
                        (float)g_globals.screen_distortion->scatter_X_axes[i+1], 
						(float)g_globals.screen_distortion->scatter_Y_axes[i+1] );
    }

    glLineWidth(1.);
    canvas->SetForeground(interface_color[GRID1]);
    for (i = 0;i < g_globals.dataset->dims;i++)
        for (int j = 0;j < g_globals.dataset->dims;j++)
            canvas->DrawRectangle2(g_globals.screen_distortion->scatter_X_axes[i], g_globals.screen_distortion->scatter_X_axes[i+1], 
                                   g_globals.screen_distortion->scatter_Y_axes[j], g_globals.screen_distortion->scatter_Y_axes[j+1] );
    
/* for fisheye view
	int i;
	for ( i = 0; i <= g_globals.dataset->dims; i++ )
		canvas->DrawLineTemp(g_globals.screen_distortion->scatter_X_axes[i], g_globals.screen_distortion->scatter_Y_axes[0],
								g_globals.screen_distortion->scatter_X_axes[i], g_globals.screen_distortion->scatter_Y_axes[g_globals.dataset->dims]);
	for ( i = 0; i <= g_globals.dataset->dims; i++ )
		canvas->DrawLineTemp(g_globals.screen_distortion->scatter_X_axes[0], g_globals.screen_distortion->scatter_Y_axes[i],
								g_globals.screen_distortion->scatter_X_axes[g_globals.dataset->dims], g_globals.screen_distortion->scatter_Y_axes[i]);
*/

//jing draw the labels of the plots
    // do labels
    canvas->SetForeground(interface_color[TEXT]);

    Vec2 font_size = canvas->GetDataFontSize("W");

    // draw horizontal labels
    // add letters one at a time until space runs out

	// PAUL: scatter_bounds
    for (i=xMinDim; i<xMaxDim; i++)
    {
        double y = .8*font_size.Y;
        
        char name[50], name_a[30];
        strcpy(name, g_globals.dataset->names[i]);
        sprintf(name_a, "(%1d)", g_globals.dim_reducer->GetEntries(i));
        strcat(name, name_a);

        canvas->DrawConfinedString(g_globals.screen_distortion->scatter_X_axes[i],y,name,
								   g_globals.screen_distortion->scatter_X_interval[i]-font_size.X*3);
    }

    // draw vertical labels
    // add letters one at a time until space runs out
	// PAUL: scatter_bounds
	for (i=yMinDim; i<yMaxDim; i++)
    {
        // initial coordinates
        Vec2 p;
        p.X = -2.5*font_size.X;
        p.Y = g_globals.screen_distortion->scatter_Y_axes[i]; // - font_size.Y*1.1;

        char name[50], name_a[30];
        strcpy(name, g_globals.dataset->names[i]);
        sprintf(name_a, "(%1d)", g_globals.dim_reducer->GetEntries(i));
        strcat(name, name_a);

        for (int j=0; j<int(strlen(name)); j++)
        {
            Vec2 letter = canvas->GetDataFontSize(&g_globals.dataset->names[i][j],1);
            p.Y -= 1.2*letter.Y;

            if (p.Y > g_globals.screen_distortion->scatter_Y_axes[i+1]+letter.Y) break;

            canvas->DrawString(p.X,p.Y,&name[j],1);
        }
    }
}


// Draw grid.
void CScatter::DrawScatterGridWideAxes(grCanvas *canvas)
{
    int i;
    glShadeModel(GL_SMOOTH);
    canvas->SetXorMode(false);

    canvas->SetForeground(interface_color[GRID1]);
    for (i = 0;i < g_globals.dataset->dims;i++)
    {        
        if ( ! g_globals.dim_reducer->IsLeafDim(i) )
        {
            double dim_disagreement = g_globals.dim_reducer->GetDimDisagreement(i);
            glLineWidth((float)(1.+ dim_disagreement * 10.));

            for ( int j = 0; j <= g_globals.dataset->dims; j++ )
            {
                canvas->DrawLine((float)g_globals.screen_distortion->scatter_X_axes[i], 
								(float)g_globals.screen_distortion->scatter_Y_axes[j], 
								(float)g_globals.screen_distortion->scatter_X_axes[i+1], 
								(float)g_globals.screen_distortion->scatter_Y_axes[j] );
                canvas->DrawLine((float)g_globals.screen_distortion->scatter_X_axes[j], 
								(float)g_globals.screen_distortion->scatter_Y_axes[i], 
								(float)g_globals.screen_distortion->scatter_X_axes[j], 
								(float)g_globals.screen_distortion->scatter_Y_axes[i+1]);
            }
        }
    }

    glLineWidth(1.);
    canvas->SetForeground(interface_color[GRID1]);
    for (i = 0;i < g_globals.dataset->dims;i++)
        for (int j = 0;j < g_globals.dataset->dims;j++)
            canvas->DrawRectangle2(g_globals.screen_distortion->scatter_X_axes[i], g_globals.screen_distortion->scatter_X_axes[i+1], 
                                   g_globals.screen_distortion->scatter_Y_axes[j], g_globals.screen_distortion->scatter_Y_axes[j+1] );
    
/* for fisheye view
	int i;
	for ( i = 0; i <= g_globals.dataset->dims; i++ )
		canvas->DrawLineTemp(g_globals.screen_distortion->scatter_X_axes[i], g_globals.screen_distortion->scatter_Y_axes[0],
								g_globals.screen_distortion->scatter_X_axes[i], g_globals.screen_distortion->scatter_Y_axes[g_globals.dataset->dims]);
	for ( i = 0; i <= g_globals.dataset->dims; i++ )
		canvas->DrawLineTemp(g_globals.screen_distortion->scatter_X_axes[0], g_globals.screen_distortion->scatter_Y_axes[i],
								g_globals.screen_distortion->scatter_X_axes[g_globals.dataset->dims], g_globals.screen_distortion->scatter_Y_axes[i]);
*/

//jing draw the labels of the plots
    // do labels
    canvas->SetForeground(interface_color[TEXT]);

    Vec2 font_size = canvas->GetDataFontSize("W");

    // draw horizontal labels
    // add letters one at a time until space runs out
    for (i=0; i<g_globals.dataset->dims; i++)
    {
        double y = .8*font_size.Y;
        
        char name[50], name_a[30];
        strcpy(name, g_globals.dataset->names[i]);
        sprintf(name_a, "(%1d)", g_globals.dim_reducer->GetEntries(i));
        strcat(name, name_a);

        canvas->DrawConfinedString(g_globals.screen_distortion->scatter_X_axes[i],y,name,
								   g_globals.screen_distortion->scatter_X_interval[i]-font_size.X*3);
    }

    // draw vertical labels
    // add letters one at a time until space runs out
    for (i=0; i<g_globals.dataset->dims; i++)
    {
        // initial coordinates
        Vec2 p;
        p.X = -2.5*font_size.X;
        p.Y = g_globals.screen_distortion->scatter_Y_axes[i]; // - font_size.Y*1.1;

        char name[50], name_a[30];
        strcpy(name, g_globals.dataset->names[i]);
        sprintf(name_a, "(%1d)", g_globals.dim_reducer->GetEntries(i));
        strcat(name, name_a);

        for (int j=0; j<int(strlen(name)); j++)
        {
            Vec2 letter = canvas->GetDataFontSize(&g_globals.dataset->names[i][j],1);
            p.Y -= 1.2*letter.Y;

            if (p.Y > g_globals.screen_distortion->scatter_Y_axes[i+1]+letter.Y) break;

            canvas->DrawString(p.X,p.Y,&name[j],1);
        }
    }
}

void CScatter::InputScatterFindPlot(grCanvas *canvas, int sx, int sy, int &X_dim, int &Y_dim)
{
    Vec2 p = canvas->MapScreenToData( Vec2(sx,sy) );
    int i = -1, j = -1;
    while ( i < g_globals.dataset->dims && p.X > g_globals.screen_distortion->scatter_X_axes[i+1] )
        i++;
    while ( j < g_globals.dataset->dims && p.Y > g_globals.screen_distortion->scatter_Y_axes[j+1] )
        j++;

    X_dim = i;
    Y_dim = j;
    return;
}


void CScatter::InputScatterScalePlotSize(grCanvas *canvas, int X_dim, int Y_dim, double delta)
{
    if ( X_dim < 0 || X_dim >= g_globals.dataset->dims )
        return;
    if ( Y_dim < 0 || Y_dim >= g_globals.dataset->dims )
        return;

    g_globals.screen_distortion->ScatterScalePlot(X_dim, Y_dim, delta);
    return;
}


void CScatter::ScatterCaption(grCanvas *canvas, int x, int y)
{
    Vec2 p = canvas->MapScreenToData( Vec2(x,y) );

/*    double fx = p.X * g_globals.dataset->dims;
    double fy = p.Y * g_globals.dataset->dims;
    if (fx<0 || fy<0) return;

    int dim_x = int(fx);
    int dim_y = int(fy);
    dim_x = CLAMP(dim_x,0,g_globals.dataset->dims-1);
    dim_y = CLAMP(dim_y,0,g_globals.dataset->dims-1);
*/
    int dim_x, dim_y;
    InputScatterFindPlot(canvas, x, y, dim_x, dim_y);
    dim_x = CLAMP(dim_x,0,g_globals.dataset->dims-1);
    dim_y = CLAMP(dim_y,0,g_globals.dataset->dims-1);

    double datax = XINVMAP(dim_x,p.X);
    double datay = YINVMAP(dim_y,p.Y);

    char caption[100];
    sprintf(caption,"%s=",g_globals.dataset->names[dim_x]);

	//Commented by Zaixian to add caption of nominal fields in the status bar
	/*
    if (g_globals.dataset->nominal_fields[dim_x] != 0) {
//        int value = (int) rint(datax);
//jing 
		int value = (int)(datax+0.5);
//jing
        const char *string = g_globals.dataset->nominal_fields[dim_x]->MapValueToString(value);
        strcat(caption,string);
        strcat(caption," ");
    } else {
        sprintf(caption, "%s%.2lf ", caption, datax);
    }
	*/
	//Added by Zaixian to add caption of nominal fields in the status bar
	strcat(caption, g_globals.dataset->MapValueToString(dim_x, datax));
    
	strcat(caption,", ");
    strcat(caption,g_globals.dataset->names[dim_y]);
    strcat(caption,"=");

	//Commented by Zaixian to add caption of nominal fields in the status bar
	/*
	if (g_globals.dataset->nominal_fields[dim_y] != 0) {
 //       int value = (int) rint(datay);
//jing
		int value = (int)(datay+0.5);
//jing

        const char *string = g_globals.dataset->nominal_fields[dim_y]->MapValueToString(value);
        strcat(caption,string);
        strcat(caption," ");
    } else {
        sprintf(caption, "%s%.2lf ", caption, datay);
    }
	*/
	//Added by Zaixian to add caption of nominal fields in the status bar
	strcat(caption, g_globals.dataset->MapValueToString(dim_y, datay));

	appShowCanvasMessage(Togl_Interp(canvas->GetWidget()),caption, canvas->name);
}



double CScatter::XMAP(int DIM, double VAL) 
{
	// PAUL: precalc_math
    return g_globals.screen_distortion->scatter_X_axes[DIM] + ( VAL - g_globals.dataset->dim_min[DIM] ) * xMapFactor[DIM];
	/*
    return g_globals.screen_distortion->scatter_X_axes[DIM] + 
           ( VAL - g_globals.dataset->dim_min[DIM] ) * ( g_globals.screen_distortion->scatter_X_axes[DIM+1] - g_globals.screen_distortion->scatter_X_axes[DIM] ) 
             / (g_globals.dataset->dim_max[DIM] - g_globals.dataset->dim_min[DIM] );
	*/
}


double CScatter::YMAP(int DIM, double VAL)
{
	// PAUL: precalc_math
	return g_globals.screen_distortion->scatter_Y_axes[DIM] + (g_globals.dataset->dim_max[DIM] - VAL) * yMapFactor[DIM];
	/*
    return g_globals.screen_distortion->scatter_Y_axes[DIM] + 
           ( (g_globals.dataset->dim_max[DIM] - VAL) * (g_globals.screen_distortion->scatter_Y_axes[DIM+1] - g_globals.screen_distortion->scatter_Y_axes[DIM] ) 
             / (g_globals.dataset->dim_max[DIM] - g_globals.dataset->dim_min[DIM]) );
	*/
}


//reverse of xmap. map screen back to data
double CScatter::XINVMAP(int DIM, double VAL)
{
    return (VAL-g_globals.screen_distortion->scatter_X_axes[DIM]) * (g_globals.dataset->dim_max[DIM] - g_globals.dataset->dim_min[DIM]) 
            / (g_globals.screen_distortion->scatter_X_axes[DIM+1] - g_globals.screen_distortion->scatter_X_axes[DIM] ) 
           + g_globals.dataset->dim_min[DIM];
}


double CScatter::YINVMAP(int DIM, double VAL)
{
    return g_globals.dataset->dim_max[DIM] - 
           ( VAL - g_globals.screen_distortion->scatter_Y_axes[DIM] ) * ( g_globals.dataset->dim_max[DIM] - g_globals.dataset->dim_min[DIM] ) 
             / ( g_globals.screen_distortion->scatter_Y_axes[DIM+1] - g_globals.screen_distortion->scatter_Y_axes[DIM] );
}


// PAUL: scatter_bounds
// Find the 2D range of dimensions that are visible to the user
// so that hidden parts of the canvas can be ignored
void CScatter::SetDimBounds(grCanvas * canvas)
{
	const int DimCount = g_globals.dataset->dims;

	xMinDim = 0;
	yMinDim = 0;

	int clientSize[2];
	canvas->GetSize(clientSize + 0, clientSize + 1);

	// Used to find out how many pixels fit on inside of a dimension 'unit' by finding
	// the virtual bounds of the viewport
	Vec2	vBottomLeft = canvas->MapScreenToData(Vec2(0,0)),
			vTopRight = canvas->MapScreenToData(Vec2(clientSize[0], clientSize[1]));
	xMaxDim = DimCount;
	yMaxDim = DimCount;

	// Find the range of dimensions for each axis
	if (g_globals.screen_distortion->scatter_X_axes[0] >= vBottomLeft.X)
		xMinDim = 0;
	else
	{
		xMinDim = DimCount - 1;
		for (int j = DimCount - 1 ; j >= 0; j--)
		{
			if (g_globals.screen_distortion->scatter_X_axes[j] <= vBottomLeft.X)
			{
				xMinDim = j;
				break;
			}
		}
	}

	if (g_globals.screen_distortion->scatter_X_axes[DimCount] <= vTopRight.X)
		xMaxDim = DimCount;
	else
	{
		xMaxDim = DimCount;
		for (int j = 0 ; j < DimCount; j++)
		{
			if (g_globals.screen_distortion->scatter_X_axes[j] >= vTopRight.X)
			{
				xMaxDim = j;
				break;
			}
		}
	}

	// Y
	if (g_globals.screen_distortion->scatter_Y_axes[0] >= vBottomLeft.Y)
		yMinDim = 0;
	else
	{
		yMinDim = DimCount - 1;
		for (int j = 0 ; j < DimCount; j++)
		{
			if (g_globals.screen_distortion->scatter_Y_axes[j] <= vBottomLeft.Y)
			{
				yMinDim = j;
				break;
			}
		}
	}

	if (g_globals.screen_distortion->scatter_Y_axes[DimCount] <= vTopRight.Y)
		yMaxDim = DimCount;
	else
	{
		yMaxDim = DimCount;
		for (int j = DimCount ; j > 0; j--)
		{
			if (g_globals.screen_distortion->scatter_Y_axes[j] >= vTopRight.Y)
			{
				yMaxDim = j;
				break;
			}
		}
	}

	// PAUL: precalc_math
	// Precalculate costly factors that for XMAP and YMAP
	xMapFactor.SetLen(g_globals.dataset->dims);
	yMapFactor.SetLen(g_globals.dataset->dims);
	for (int DIM = 0; DIM < g_globals.dataset->dims; ++DIM)
	{
		double inv = 1.0 / (g_globals.dataset->dim_max[DIM] - g_globals.dataset->dim_min[DIM] );

		xMapFactor[DIM] = inv * ( g_globals.screen_distortion->scatter_X_axes[DIM+1] - g_globals.screen_distortion->scatter_X_axes[DIM] ); 
		yMapFactor[DIM] = inv * ( g_globals.screen_distortion->scatter_Y_axes[DIM+1] - g_globals.screen_distortion->scatter_Y_axes[DIM] ); 
	}
}
