///////////////////////////////////////////////////////////////////////////////
/// \file PixelOriented.cpp
/// \brief Implementation of the CPixelOriented class
/// \date 7/12/2004
/// \author Anilkumar Patro
///////////////////////////////////////////////////////////////////////////////

// SYSTEM INCLUDES
//
#include <cstdlib>
#include <sstream>
using namespace std;

#include <togl.h>
#include <GL/glu.h>

// PROJECT INCLUDES
//
#include <xmdv/PixelOriented.h>
#include <xmdv/XmdvTool.h>
#include <xmdv/ogl.h>
#include <xmdv/brush.h>

// DEFINES
//

// FORWARD REFERENCES
//

//-----------------------------------------------------------------------------
CPixelOriented::CPixelOriented()
{
	// TODO: Add constructor
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
CPixelOriented::CPixelOriented(const CPixelOriented& from)
{
	// TODO: Add copy constructor
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
/*virtual*/ CPixelOriented::~CPixelOriented()
{
	// TODO: Add destructor
}
//-----------------------------------------------------------------------------

//-------------------------------------------------------------------------
CPixelOriented& CPixelOriented::operator = (const CPixelOriented& from)
{
	if (this == &from)
		return *this;

	// TODO: Add assignment operator

	return *this;
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
double CPixelOriented::YMAP(int X, double Y)
{
	return 1.0-(Y - g_globals.dataset->dim_min[X]) / 
		(g_globals.dataset->dim_max[X] - g_globals.dataset->dim_min[X]);
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//it is for the uniformed dim: 0-1
double CPixelOriented::YMAP(double Y)
{
	return 1.0-Y;
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
double CPixelOriented::YINVMAP(int X, double Y)
{
	return ((1.0-(Y))
			* (g_globals.dataset->dim_max[X] - g_globals.dataset->dim_min[X]))
			+ (g_globals.dataset->dim_min[X]);
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
Vec2 CPixelOriented::MapScreenToCMapData(const Vec2& sc)
{
	GLdouble modelMatrix[16] = { 1,0,0,0, 0,1,0,0, 0,0,1,0, 0,0,0,1 };
	GLdouble projMatrix[16];
	GLint viewport[4];
	//glGetDoublev(GL_MODELVIEW_MATRIX,modelMatrix);
	glGetDoublev(GL_PROJECTION_MATRIX,projMatrix);
	glGetIntegerv(GL_VIEWPORT,viewport);

	double wc[3];
	int ret = gluUnProject(sc.X,sc.Y,0,modelMatrix,projMatrix,viewport,wc,wc+1,wc+2);
	assert(ret == GL_TRUE);
	return Vec2(wc[0],wc[1]);
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
void CPixelOriented::GetNormalizedBrushExtents(Brush* brush, int dim, 
											   double& max, double& min)
{
	max = (brush->Max(dim)  - g_globals.dataset->dim_min[dim]) /
		(g_globals.dataset->dim_max[dim] - g_globals.dataset->dim_min[dim]);
	min = (brush->Min(dim)  - g_globals.dataset->dim_min[dim]) /
		(g_globals.dataset->dim_max[dim] - g_globals.dataset->dim_min[dim]);
}
//-----------------------------------------------------------------------------
