#include <CacheIterator.h>
#include <Iterator.h>
#include <ICacheEntry.h>
#include <ILoad.h>
#include <ServedItemVisitor.h>

using namespace cache;

CacheIterator::CacheIterator(Iload *iload,		
			  std::queue<ICacheEntry*>* cacheQueue,
			  ServedItemVisitor* servedItemVisitor)
{
	this->iload = iload;
	this->cacheQueue = cacheQueue;	
	this->servedItemVisitor = servedItemVisitor;
	this->count = 0;
}	

ICacheEntry* CacheIterator:: get_next()
{
	ICacheEntry* cacheEntry=NULL;		
	if(cacheQueue->empty())
	{
		iload->loadLeftOver();
		if(cacheQueue->empty())
			return(cacheEntry);		
	} // if(cacheQueue->empty())
	cacheEntry = cacheQueue->front();	
	servedItemVisitor->servedItem(*cacheEntry);
	cacheEntry->setNew(false);
	cacheQueue->pop();
	count++;
	return(cacheEntry);
}


bool  CacheIterator:: isDone()
{
	bool result = false;
	if(cacheQueue->empty())
	{
		iload->loadLeftOver();
		if(cacheQueue->empty())			
			result = true;			
	} // if(cacheQueue->empty())
	return(result);
}

CacheIterator:: ~CacheIterator()
{
	//Just in case the iterator has been deleted without
	//reading all the elements from the iterator
	while(!cacheQueue->empty())
	{
		ICacheEntry* cacheEntry = cacheQueue->front();			
		servedItemVisitor->servedItem(*cacheEntry);
		cacheEntry->setNew(false);
		cacheQueue->pop();
		count++;
	}
	this->iload->endLoad(count);
}

