#include <CacheSearcher.h>
#include <Brush.h>
#include <ICacheEntry.h>

using namespace cache;

CacheSearcher::CacheSearcher(std::list<ICacheEntry*>* resultList)
{	
	this->resultList = resultList;
}

void CacheSearcher::setSearchParameters(Brush *in)
{
	this->currentBrush = in;	
}

//Visitor functions
ICacheEntry* CacheSearcher::convertToPointer(unsigned char* data)
{
	int n = sizeof(ICacheEntry*);	
	unsigned long lLong= 0;
	unsigned long output = 0;
	for(int i =n-1;i>=0;i--)
	{
		lLong = data[i];
		output = output | (lLong<<i*8);
		//printf(" byte order = %d byte = %x output = %x \n",i,data[i],output);
	} // for(unsigned char i =n-1;i>=0;i--)

	return((ICacheEntry*) output);
}

void CacheSearcher:: visitNode(const SpatialIndex::INode &in)
{}

//Helper functions
void CacheSearcher:: visitData(const SpatialIndex::IData &in)
{
	unsigned long length;
	Tools::Geometry::IShape *iShape=NULL;
	//Makes a new iShape object
	in.getShape(&iShape);
	if(this->currentBrush->inBrush(*iShape))
	{

		byte *data=NULL;
		//Allocates a new array.
		in.getData(length,&data); //(*data) contains the actual data in one dimensional array		
		//This makes a new data item
		ICacheEntry* cacheEntryPtr = convertToPointer(data);						
		//Delete the new array allocated
		delete(data);
		this->resultList->push_back(cacheEntryPtr);
	} // if(this->currentBrush->inBrush(*iShape))
	//HAve to delete the iShpae
	delete(iShape);
}


